﻿@attribute [Authorize(Roles = "Administrator, superuser")]
@page "/admin/package"
@layout Shared.Admin.MainLayout

@using Model.Dto.Package;
@using Dakaris.Client.Shared.MessageBox;
@using Model.Enum

<center>
    <h3>Packages</h3>
    <br /><br />
    <div class="container-fluid">
        <EditForm Model="@packageDto" OnValidSubmit="@(e => SubmitAsync(packageDto))">

            <DataAnnotationsValidator />

            @*<ValidationSummary />*@

            <div>
                <div>
                    <input type="hidden" @bind="packageDto.IsActive" />
                    <input type="hidden" @bind="packageDto.Id" />
                    <input type="hidden" @bind="packageDto.MaxViewCount" />
                </div>

                <div class="col-10 row">
                    <label for="Amount" class="col-sm-4 col-form-label d-flex flex-row-reverse">Package Amount: RS.</label>
                    <div class="form-group row col-6">
                        <input type="text" disabled="@FieldDisabled" placeholder="Amount" @bind="packageDto.Price" class="form-control" />
                        <ValidationMessage For="@(() => packageDto.Price)" />
                    </div>
                </div>

                <div class="col-10 row">
                    <label for="Details" class="col-sm-4 col-form-label d-flex flex-row-reverse">Package Details: </label>
                    <div class="form-group row col-6">
                        <input type="text" disabled="@FieldDisabled" placeholder="Details" @bind="packageDto.Description" class="form-control" />
                        <ValidationMessage For="@(() => packageDto.Description)" />
                    </div>
                </div>

                <div class="col-10 row">
                    <label for="SelectPackage" class="col-sm-4 col-form-label d-flex flex-row-reverse">Package Type: </label>
                    <div class="form-group row col-6">
                        <select class="form-control" @onchange=@packageSelectionChange value="@packageDto.Name">
                            <option value="default" selected>select package</option>
                            @foreach (var packageType in Enum.GetValues(typeof(PackageTypes)))
                            {
                                <option>@packageType</option>
                            }
                        </select>
                        <ValidationMessage For="@(() => packageDto.Name)" />
                    </div>
                </div>
                <div>
                    <button type="submit" disabled="@OkayDisabled" name="Edit" class="btn btn-warning"><span class="oi oi-pencil"></span> Edit</button>
                    <span>&nbsp;&nbsp;</span>
                    <button type="button" @onclick="FormReset" name="Reset" class="btn btn-primary"><span class="oi oi-reload"></span> Reset</button>
                </div>
            </div>
        </EditForm>
    </div>
</center>

@*@if (ShowList)
    {
    <section id="list">
        <button class="btn btn-primary" @onclick="@(e => GetDetailViewAsync(0,"Create"))">Add New</button>
        <br /><br />
        @if (packageList == null)
        {
            <p><em>Loading...</em></p>
        }
        else
        {
            <center>
                <table class="table">
                    <thead>
                        <tr>
                            <th hidden>Id</th>
                            <th>Name</th>
                            <th>Description</th>
                            <th>Price</th>
                            <th>View Count</th>
                            <th>Status</th>
                            <th> </th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach (var package in packageList)
                        {
                            <tr>
                                <td hidden>@package.Id</td>
                                <td>@package.Name</td>
                                <td>@package.Description</td>
                                <td>@package.Price</td>
                                <td>@package.MaxViewCount</td>
                                <td><input type="checkbox" id="status" checked="@package.IsActive" disabled readonly="readonly" /> Active</td>
                                <td>
                                    <button type="button" @onclick="@(e => GetDetailViewAsync(package.Id,"Update"))" name="Edit" class="btn btn-warning"><span class="oi oi-pencil"></span></button>
                                    <span>&nbsp;|&nbsp;</span>
                                    <button type="button" @onclick="@(e => clickDel(package.Id))" name="Delete" class="btn btn-danger"><span class="oi oi-trash"></span></button>
                                </td>
                            </tr>
                        }
                    </tbody>
                </table>
                <div>
                    <ConfirmationBox OnClickYes="@DeleteRecord" MsgHeader="Confirm Delete" MsgBody="Are you sure ?" MsgShow="@delMsgShow" MsgId="@delMsgId"></ConfirmationBox>
                </div>
            </center>
        }
    </section>
    }
    else
    {
        <section id="form" class="offset-2 col-8">
            <EditForm Model="@packageDto" OnValidSubmit="@(e => SubmitAsync(packageDto,FromType))">

                <DataAnnotationsValidator />

                <ValidationSummary />

                <div class="form-group">
                    <label for="Name">Package Name: </label>
                    <input type="text" placeholder="Name" @bind="packageDto.Name" class="form-control" />
                    <ValidationMessage For="@(() => packageDto.Name)"/>
                </div>
                <div class="form-group">
                    <label for="Name">Pacage Details: </label>
                    <input type="text" placeholder="Detals" @bind="packageDto.Description" class="form-control" />
                    <ValidationMessage For="@(() => packageDto.Description)" />
                </div>

                <div class="form-group">
                    <label for="Name">Package Amount: </label>
                    <input type="text" placeholder="Amount" @bind="packageDto.Price" class="form-control" />
                    <ValidationMessage For="@(() => packageDto.Price)" />
                </div>
                <div class="form-group">
                    <label for="Name">Max Count: </label>
                    <input type="text" placeholder="Max Count" @bind="packageDto.MaxViewCount" class="form-control" />
                    <ValidationMessage For="@(() => packageDto.MaxViewCount)" />
                </div>
                <div class="form-group form-inline">
                    <label for="Name">Status: </label>&nbsp;&nbsp;
                    <input type="checkbox" placeholder="Is Active" @bind="packageDto.IsActive" class="form-control form-check-inline" />
                    <span>@(packageDto.IsActive ? "Active" : "DeActive") </span>
                    <ValidationMessage For="@(() => packageDto.IsActive)" />
                </div>

                <div class="float-right d-inline-flex">
                    <button type="submit" name="Submit" disabled="@OkayDisabled" class="btn btn-success">Submit</button>&nbsp;&nbsp;
                    <button type="reset" name="Reset" @onclick="FormReset" class="btn btn-primary">Reset</button>&nbsp;&nbsp;
                    <button type="button" name="Cancel" @onclick="FormCancel" class="btn btn-primary">Cancel</button>
                </div>

            </EditForm>
        </section>
    }*@

@code {

}
